// xaira-php.cpp : Defines the entry point for the DLL application.
//
#define _USE_32BIT_TIME_T 1

/* include standard header */ 
/* you will need to include this in all of your php extension projects*/ 
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_NON_CONFORMING_SWPRINTFS
#include "php.h" 
#include "php_ini.h"
#include "zend_exceptions.h"
#include "info.h"
typedef unsigned short xairo_uchar;
#include "XairoPHPError.h"

bool xairainit(const char*,const char*,const char*);
const char* gcn(int);
const char* gcp(int);
int gcc();
const char* _getCorpusName(void*);
const char* _getCorpusPath(void*);
void* _getWordList(void*,const char*,const char*);
void* _getAddkeyValueList(void*,void*);
void* _getAttributeValueList(void*,void*);
void* _getFrequencyList(void*,const char*,int,int,int,const char*);
void* _getFilteredFrequencyList(void*,const char*,int,int,int,const char*,void*);
void* _getUsage(void*,int);
int WordList_getCount(void*);
void* WordList_getWord(void*,int);
int AddkeyValueList_getCount(void*);
void* AddkeyValueList_getAddkeyValue(void*,int);
int AttributeValueList_getCount(void*);
void* AttributeValueList_getAttributeValue(void*,int);
int Word_getFrequency(void*);
int Word_getFilteredFrequency(void*,void*);
int Word_getFormCount(void*);
char* AddkeyValue_getValue(void*);
int AddkeyValue_getFrequency(void*);
char* AttributeValue_getValue(void*);
int AttributeValue_getFrequency(void*);
int AttributeValue_getFilteredFrequency(void*,void*);
char* Word_getNorm(void*,int);
void* Word_getForm(void*,int);
char* Form_getNorm(void*);
char* Form_getText(void*);
int Form_getFrequency(void*);
int Form_getFilteredFrequency(void*,void*);
char* Form_getAdditionalKey(void*,const char*);
char* CorpusText_getTitle(void*);
void* CorpusText_evalXpath(void*,const char*);
bool CorpusText_isSelected(void*,void*);
int CorpusText_classify(void*,void*);
int CorpusText_getWordCount(void*);
char* XpathValue_getText(void*);
int CorpusTextList_getCount(void*);
void* CorpusTextList_getCorpusText(void*,int);
void* CorpusTextList_getCorpusTextFilter(void*,int,int*);
void* _solve(void*,const char*);
void* Solution_getHit(void*,int);
void* Solution_thinCorpusTextFilter(void*,void*);
void* Solution_thinRand(void*,int,int);
void* Solution_thinInit(void*,int);
void* Solution_thinOpt(void*);
void* Solution_thinSelection(void*,int,int*);
void* Solution_thinCollocation(void*,const char*,int,int,int,const char**);
void* Solution_thinCollocationX(void*,const char*,const char*,const char*,int,const char**);
int Solution_getCount(void*);
void Solution_analysis(void*,int,int*,int,int*,int*);
void* Solution_makeCollocationTable(void*,const char*,const char*,int,int,int,int,double,double,int);
void* Solution_makeCollocationTableX(void*,const char*,const char*,int,const char*,const char*,int,double,double,int);
char* Hit_getText(void*,int,int);
char* Hit_getUnit(void*);
void* Hit_getCorpusText(void*);
int Hit_getCursorStart(void*);
int Hit_getCursorEnd(void*);
void* _getServer(const char*);
void* _getGrammar(void*);
void* _getCorpusTextList(void*);
int Grammar_getAddkeyCount(void*);
char* GrammarAddkey_getName(void*);
bool GrammarAddkey_isLemmaScheme(void*);
void* Grammar_getAddkey(void*,int);
int Grammar_getLemmaSchemeCount(void*);
void* Grammar_getLemmaScheme(void*,int);
char* GrammarLemmaScheme_getName(void*);
char* GrammarLemmaScheme_getGloss(void*);
int GrammarLemmaScheme_getFacetCount(void*);
char* GrammarLemmaScheme_getFacet(void*,int);
void* Grammar_getRootPartition(void*);
char* GrammarPartition_getName(void*);
char* GrammarPartition_getDescription(void*);
int GrammarPartition_getCount(void*);
void* GrammarPartition_getDivision(void*,int);
int Grammar_getElementCount(void*);
void* Grammar_getElement(void*,int);
char* GrammarElement_getName(void*);
char* GrammarElement_getGloss(void*);
char* GrammarElement_getNamespace(void*);
int GrammarElement_getAttributeCount(void*);
void* GrammarElement_getAttribute(void*,int);
char* GrammarAttribute_getName(void*);
char* GrammarAttribute_getGloss(void*);
char* GrammarAttribute_getNamespace(void*);
int CollocationTable_getCount(void*);
void* CollocationTable_getCollocate(void*,int);
void* Collocate_getWord(void*);
int Collocate_getHits(void*);
double Collocate_getScore(void*);
int ExtendedForm_getType(void*);
char* ExtendedForm_getNorm(void*);
char* ExtendedForm_getText(void*);
char* ExtendedForm_getData(void*,int);
void* _deserialize(void*,const char*);
char* Solution_serialize(void*);
char* CorpusTextFilter_serialize(void*);
char* _transcode(const char*);
char* _transcode2(const char*);
const char* _getTempPath();
const char* _getDataPath();
void debuglog(const char*);
void cleanup(int,void*);

extern int kserver;

struct xaira_object {
	zend_object std;
	void* ptr;
	bool bInit;
	bool bDelete;
	int dt;
	xaira_object():ptr(NULL),bInit(false),bDelete(true),dt(0) {}
};

extern "C" {

/* All the functions that will be exported (available) must be declared */ 

ZEND_FUNCTION(getXairaServer);

PHP_METHOD(XairaServer,getCorpusName); 
PHP_METHOD(XairaServer,getCorpusPath); 
PHP_METHOD(XairaServer,getWordList);
PHP_METHOD(XairaServer,getAddkeyValueList);
PHP_METHOD(XairaServer,getAttributeValueList);
PHP_METHOD(XairaServer,getFrequencyList);
PHP_METHOD(XairaServer,getFilteredFrequencyList);
PHP_METHOD(XairaServer,solve);
PHP_METHOD(XairaServer,getGrammar);
PHP_METHOD(XairaServer,getCorpusTextList);
PHP_METHOD(XairaServer,getUsage);
PHP_METHOD(XairaServer,deserialize);
PHP_METHOD(XairaServer,transcode);
PHP_METHOD(XairaServer,transcode2);
PHP_METHOD(XairaServer,getXairaServer);
PHP_METHOD(XairaServer,getXairaCorpora);


PHP_METHOD(XairoWordList,getCount);
PHP_METHOD(XairoWordList,getWord);

PHP_METHOD(XairoAddkeyValueList,getCount);
PHP_METHOD(XairoAddkeyValueList,getAddkeyValue);

PHP_METHOD(XairoAttributeValueList,getCount);
PHP_METHOD(XairoAttributeValueList,getAttributeValue);

PHP_METHOD(XairoWord,getFrequency);
PHP_METHOD(XairoWord,getFilteredFrequency);
PHP_METHOD(XairoWord,getNorm);
PHP_METHOD(XairoWord,getFormCount);
PHP_METHOD(XairoWord,getForm);

PHP_METHOD(XairoAddkeyValue,getFrequency);
PHP_METHOD(XairoAddkeyValue,getValue);

PHP_METHOD(XairoAttributeValue,getFrequency);
PHP_METHOD(XairoAttributeValue,getFilteredFrequency);
PHP_METHOD(XairoAttributeValue,getValue);

PHP_METHOD(XairoForm,getNorm);
PHP_METHOD(XairoForm,getText);
PHP_METHOD(XairoForm,getAdditionalKey);
PHP_METHOD(XairoForm,getFrequency);
PHP_METHOD(XairoForm,getFilteredFrequency);

PHP_METHOD(XairoSolution,getCount);
PHP_METHOD(XairoSolution,getHit);
PHP_METHOD(XairoSolution,makeCollocationTable);
PHP_METHOD(XairoSolution,serialize);
PHP_METHOD(XairoSolution,thinCorpusTextFilter);
PHP_METHOD(XairoSolution,thinRand);
PHP_METHOD(XairoSolution,thinInit);
PHP_METHOD(XairoSolution,thinOnePerText);
PHP_METHOD(XairoSolution,thinSelection);
PHP_METHOD(XairoSolution,thinCollocation);
PHP_METHOD(XairoSolution,analysis);

PHP_METHOD(XairoHit,getText);
PHP_METHOD(XairoHit,getHit);
PHP_METHOD(XairoHit,getCorpusText);
PHP_METHOD(XairoHit,getUnit);
PHP_METHOD(XairoHit,getCursorStart);
PHP_METHOD(XairoHit,getCursorEnd);

PHP_METHOD(XairoCorpusTextList,getCount);
PHP_METHOD(XairoCorpusTextList,getCorpusText);
PHP_METHOD(XairoCorpusTextList,getCorpusTextFilter);

PHP_METHOD(XairoCorpusTextFilter,serialize);

PHP_METHOD(XairoCorpusText,getTitle);
PHP_METHOD(XairoCorpusText,evalXpath);
PHP_METHOD(XairoCorpusText,isSelected);
PHP_METHOD(XairoCorpusText,classify);
PHP_METHOD(XairoCorpusText,getWordCount);

PHP_METHOD(XairoXpathValue,getText);

PHP_METHOD(XairoGrammar,getAddkeyCount);
PHP_METHOD(XairoGrammar,getAddkey);
PHP_METHOD(XairoGrammar,getLemmaSchemeCount);
PHP_METHOD(XairoGrammar,getLemmaScheme);
PHP_METHOD(XairoGrammar,getRootPartition);
PHP_METHOD(XairoGrammar,getElementCount);
PHP_METHOD(XairoGrammar,getElement);

PHP_METHOD(XairoGrammarAddkey,getName);
PHP_METHOD(XairoGrammarAddkey,isLemmaScheme);

PHP_METHOD(XairoGrammarLemmaScheme,getName);
PHP_METHOD(XairoGrammarLemmaScheme,getGloss);
PHP_METHOD(XairoGrammarLemmaScheme,getFacetCount);
PHP_METHOD(XairoGrammarLemmaScheme,getFacet);

PHP_METHOD(XairoGrammarPartition,getName);
PHP_METHOD(XairoGrammarPartition,getDescription);
PHP_METHOD(XairoGrammarPartition,getCount);
PHP_METHOD(XairoGrammarPartition,getDivision);

PHP_METHOD(XairoGrammarElement,getName);
PHP_METHOD(XairoGrammarElement,getGloss);
PHP_METHOD(XairoGrammarElement,getNamespace);
PHP_METHOD(XairoGrammarElement,getAttributeCount);
PHP_METHOD(XairoGrammarElement,getAttribute);

PHP_METHOD(XairoGrammarAttribute,getName);
PHP_METHOD(XairoGrammarAttribute,getGloss);
PHP_METHOD(XairoGrammarAttribute,getNamespace);

PHP_METHOD(XairoCollocationTable,getCount);
PHP_METHOD(XairoCollocationTable,getCollocate);

PHP_METHOD(XairoCollocate,getWord);
PHP_METHOD(XairoCollocate,getHits);
PHP_METHOD(XairoCollocate,getScore);

PHP_METHOD(XairoExtendedForm,getType);
PHP_METHOD(XairoExtendedForm,getNorm);
PHP_METHOD(XairoExtendedForm,getText);
PHP_METHOD(XairoExtendedForm,getData);

PHP_MINFO_FUNCTION(xairamod); 
PHP_MINIT_FUNCTION(xairamod);




/* Just a basic int to be used as a counter*/ 
int i; 

PHP_INI_BEGIN()
PHP_INI_ENTRY("corpus_path","",PHP_INI_ALL,NULL)
PHP_INI_ENTRY("corpus_path2","",PHP_INI_ALL,NULL)
PHP_INI_ENTRY("corpus_path3","",PHP_INI_ALL,NULL)
PHP_INI_ENTRY("data_path","",PHP_INI_ALL,NULL)
PHP_INI_ENTRY("temp_path","",PHP_INI_ALL,NULL)
PHP_INI_END()

/* function list so that the Zend engine will know whats here */ 
zend_function_entry xairamod_functions[] = 
{ 
	ZEND_FE(getXairaServer, NULL)
	{NULL, NULL, NULL} 
}; 

zend_function_entry xaira_server_class_functions[] = 
{ PHP_ME(XairaServer,getCorpusName, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,getCorpusPath, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,getWordList, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,getAddkeyValueList, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,getAttributeValueList, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,getFrequencyList, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,getFilteredFrequencyList, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairaServer,solve,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,getGrammar,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,getCorpusTextList,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,getUsage,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,deserialize,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairaServer,transcode,NULL,ZEND_ACC_PUBLIC|ZEND_ACC_STATIC)
  PHP_ME(XairaServer,transcode2,NULL,ZEND_ACC_PUBLIC|ZEND_ACC_STATIC)
  PHP_ME(XairaServer,getXairaServer,NULL,ZEND_ACC_PUBLIC|ZEND_ACC_STATIC)
  PHP_ME(XairaServer,getXairaCorpora,NULL,ZEND_ACC_PUBLIC|ZEND_ACC_STATIC)
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_wordlist_class_functions[] = 
{ PHP_ME(XairoWordList,getCount, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWordList,getWord, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_addkeyvaluelist_class_functions[] = 
{ PHP_ME(XairoAddkeyValueList,getCount, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoAddkeyValueList,getAddkeyValue, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_attributevaluelist_class_functions[] = 
{ PHP_ME(XairoAttributeValueList,getCount, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoAttributeValueList,getAttributeValue, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 


zend_function_entry xaira_word_class_functions[] = 
{ PHP_ME(XairoWord,getFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWord,getFilteredFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWord,getNorm, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWord,getFormCount, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoWord,getForm, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_addkeyvalue_class_functions[] = 
{ PHP_ME(XairoAddkeyValue,getFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoAddkeyValue,getValue, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_attributevalue_class_functions[] = 
{ PHP_ME(XairoAttributeValue,getFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoAttributeValue,getFilteredFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoAttributeValue,getValue, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

  
zend_function_entry xaira_xpathvalue_class_functions[] = 
{ PHP_ME(XairoXpathValue,getText, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_form_class_functions[] = 
{ PHP_ME(XairoForm,getFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoForm,getFilteredFrequency, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoForm,getNorm, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoForm,getText, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoForm,getAdditionalKey, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_solution_class_functions[] = 
{ PHP_ME(XairoSolution,getHit, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoSolution,getCount, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoSolution,makeCollocationTable,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,serialize,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,thinCorpusTextFilter,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,thinRand,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,thinInit,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,thinOnePerText,NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoSolution,thinSelection,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,thinCollocation,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoSolution,analysis,NULL,ZEND_ACC_PUBLIC)
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_hit_class_functions[] = 
{ PHP_ME(XairoHit,getText, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoHit,getUnit, NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoHit,getCorpusText, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoHit,getCursorStart, NULL,ZEND_ACC_PUBLIC) 
  PHP_ME(XairoHit,getCursorEnd, NULL,ZEND_ACC_PUBLIC) 
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_corpustext_class_functions[] = 
{ PHP_ME(XairoCorpusText,getTitle, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusText,evalXpath, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusText,isSelected, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusText,classify, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusText,getWordCount, NULL,ZEND_ACC_PUBLIC)  
 {NULL, NULL, NULL} }; 

zend_function_entry xaira_corpustextfilter_class_functions[] = 
{
  PHP_ME(XairoCorpusTextFilter,serialize,NULL,ZEND_ACC_PUBLIC)
	
	{NULL, NULL, NULL} }; 

zend_function_entry xaira_corpustextlist_class_functions[] = 
{ PHP_ME(XairoCorpusTextList,getCount, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusTextList,getCorpusText, NULL,ZEND_ACC_PUBLIC)  
 PHP_ME(XairoCorpusTextList,getCorpusTextFilter, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_grammar_class_functions[] = {
  PHP_ME(XairoGrammar,getAddkeyCount, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammar,getAddkey, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammar,getLemmaSchemeCount, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammar,getLemmaScheme, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammar,getRootPartition,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoGrammar,getElementCount,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoGrammar,getElement,NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_grammar_addkey_class_functions[] = {
  PHP_ME(XairoGrammarAddkey,getName, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarAddkey,isLemmaScheme, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_grammar_lemmascheme_class_functions[] = {
  PHP_ME(XairoGrammarLemmaScheme,getName, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarLemmaScheme,getGloss, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarLemmaScheme,getFacetCount, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarLemmaScheme,getFacet, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 


zend_function_entry xaira_grammar_partition_class_functions[] = {
  PHP_ME(XairoGrammarPartition,getName, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarPartition,getDescription, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarPartition,getCount, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarPartition,getDivision, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_grammar_element_class_functions[] = {
  PHP_ME(XairoGrammarElement,getName, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarElement,getGloss, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarElement,getNamespace, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarElement,getAttributeCount,NULL,ZEND_ACC_PUBLIC)
  PHP_ME(XairoGrammarElement,getAttribute,NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_grammar_attribute_class_functions[] = {
  PHP_ME(XairoGrammarAttribute,getName, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarAttribute,getGloss, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoGrammarAttribute,getNamespace, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 
  
zend_function_entry xaira_collocationtable_class_functions[] = {
  PHP_ME(XairoCollocationTable,getCount, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoCollocationTable,getCollocate, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

  zend_function_entry xaira_collocate_class_functions[] = {
  PHP_ME(XairoCollocate,getWord, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoCollocate,getHits, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoCollocate,getScore, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

  zend_function_entry xaira_extendedform_class_functions[] = {
  PHP_ME(XairoExtendedForm,getType, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoExtendedForm,getNorm, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoExtendedForm,getText, NULL,ZEND_ACC_PUBLIC)  
  PHP_ME(XairoExtendedForm,getData, NULL,ZEND_ACC_PUBLIC)  
  {NULL, NULL, NULL} }; 

zend_function_entry xaira_error_class_functions[] = 
{ {NULL, NULL, NULL} }; 

#define ZEND_DEBUG 0

/* module information */ 
zend_module_entry xairamod_module_entry = 
{ STANDARD_MODULE_HEADER, 
"Xaira", 
xairamod_functions, 
PHP_MINIT(xairamod),
NULL, 
NULL, 
NULL, 
PHP_MINFO(xairamod), 
NO_VERSION_YET, 
STANDARD_MODULE_PROPERTIES }; 

#if COMPILE_DL_XAIRA_PHP 
ZEND_GET_MODULE(xairamod) 
#endif 

PHP_MINFO_FUNCTION(xairamod) 
{ 
	int i;
	php_info_print_table_start(); 
	for (i=0;i<gcc();i++) {
		char c[100]="Corpus ";
		strcat(c,gcn(i));
		php_info_print_table_row(2, c, gcp(i)); 
	}
	php_info_print_table_row(2, "Temporary path", _getTempPath()); 
	php_info_print_table_row(2, "DataPath", _getDataPath()); 
	php_info_print_table_end(); 
} 

zend_class_entry* ce_XairaServer;
zend_class_entry* ce_XairoWordList;
zend_class_entry* ce_XairoAddkeyValueList;
zend_class_entry* ce_XairoAttributeValueList;
zend_class_entry* ce_XairoWord;
zend_class_entry* ce_XairoAddkeyValue;
zend_class_entry* ce_XairoAttributeValue;
zend_class_entry* ce_XairoError;
zend_class_entry* ce_XairoSolution;
zend_class_entry* ce_XairoHit;
zend_class_entry* ce_XairoCorpusText;
zend_class_entry* ce_XairoCorpusTextFilter;
zend_class_entry* ce_XairoCorpusTextList;
zend_class_entry* ce_XairoForm;
zend_class_entry* ce_XairoGrammar;
zend_class_entry* ce_XairoGrammarAddkey;
zend_class_entry* ce_XairoGrammarLemmaScheme;
zend_class_entry* ce_XairoGrammarPartition;
zend_class_entry* ce_XairoGrammarElement;
zend_class_entry* ce_XairoGrammarAttribute;
zend_class_entry* ce_XairoCollocationTable;
zend_class_entry* ce_XairoCollocate;
zend_class_entry* ce_XairoExtendedForm;
zend_class_entry* ce_XairoXpathValue;

zend_object_handlers xaira_object_handlers;

void xaira_objects_clone(void *object, void **object_clone TSRMLS_DC)
{
	xaira_object* x=(xaira_object*) emalloc(sizeof(xaira_object));
	*x=*((xaira_object*) object);
	*object_clone=x;
}

void xaira_objects_free(void *object TSRMLS_DC)
{
    xaira_object *x = (xaira_object *) object;
    cleanup(x->dt,x->ptr); 

//    zend_hash_destroy(x->std.properties);
//    FREE_HASHTABLE(x->std.properties);

    efree(x);

}

void xperr(const char* s)
{
	zend_error(E_ERROR,s);
}

void except(const char* s TSRMLS_DC)
{
	zend_throw_exception(ce_XairoError,(char*) s,0 TSRMLS_CC);
}

zend_object_value xaira_server_objects_new(zend_class_entry *class_type TSRMLS_DC)
{
	zend_object_value retval;
	xaira_object* xo=(xaira_object*) emalloc(sizeof (xaira_object));
	xo->std.ce=class_type;
	xo->bInit=false;
	xo->dt=0;
	retval.handle = zend_objects_store_put(xo,NULL,xaira_objects_free,xaira_objects_clone TSRMLS_CC);
	retval.handlers = &xaira_object_handlers;
	return retval;
}


PHP_MINIT_FUNCTION(xairamod) 
{ 
	REGISTER_INI_ENTRIES();
	memcpy(&xaira_object_handlers, zend_get_std_object_handlers(), sizeof(zend_object_handlers));
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "XairoError", xaira_error_class_functions);
	ce_XairoError = zend_register_internal_class_ex(&ce, zend_exception_get_default(TSRMLS_C), "" TSRMLS_CC);
    INIT_CLASS_ENTRY(ce,"XairaServer",xaira_server_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairaServer=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoWordList",xaira_wordlist_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoWordList=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoAddkeyValueList",xaira_addkeyvaluelist_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoAddkeyValueList=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoAttributeValueList",xaira_attributevaluelist_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoAttributeValueList=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoWord",xaira_word_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoWord=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoAddkeyValue",xaira_addkeyvalue_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoAddkeyValue=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoAttributeValue",xaira_attributevalue_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoAttributeValue=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoSolution",xaira_solution_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoSolution=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoHit",xaira_hit_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoHit=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCorpusText",xaira_corpustext_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCorpusText=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCorpusTextFilter",xaira_corpustextfilter_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCorpusTextFilter=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCorpusTextList",xaira_corpustextlist_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCorpusTextList=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoForm",xaira_form_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoForm=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoGrammar",xaira_grammar_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoGrammar=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoGrammarAddkey",xaira_grammar_addkey_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoGrammarAddkey=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoGrammarLemmaScheme",xaira_grammar_lemmascheme_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoGrammarLemmaScheme=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoGrammarPartition",xaira_grammar_partition_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoGrammarPartition=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoGrammarElement",xaira_grammar_element_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoGrammarElement=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoGrammarAttribute",xaira_grammar_attribute_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoGrammarAttribute=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCollocationTable",xaira_collocationtable_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCollocationTable=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoCollocate",xaira_collocate_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoCollocate=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoExtendedForm",xaira_extendedform_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoExtendedForm=zend_register_internal_class(&ce TSRMLS_CC);
	INIT_CLASS_ENTRY(ce,"XairoXpathValue",xaira_xpathvalue_class_functions);
	ce.create_object = xaira_server_objects_new;
	ce_XairoXpathValue=zend_register_internal_class(&ce TSRMLS_CC);
	REGISTER_LONG_CONSTANT("XAIROCOLLOCATIONTABLE_CM_Z",0,CONST_CS|CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("XAIROCOLLOCATIONTABLE_CM_MI",1,CONST_CS|CONST_PERSISTENT);
	bool b=xairainit(INI_STR("corpus_path"),INI_STR("data_path"),INI_STR("temp_path"));
	if (b) 
		return SUCCESS;
	else
		return FAILURE;

} 

ZEND_FUNCTION(getXairaServer) { 
	if (ZEND_NUM_ARGS() > 1) WRONG_PARAM_COUNT;
	int k=0; char cn[100]; int na=0; cn[0]=0;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"|s",&cn,&k);
	cn[k]=0;
	na=ZEND_NUM_ARGS();
	void* v=na?_getServer(cn):_getServer(NULL);
//	void* v=_getServer(NULL);
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairaServer);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->bDelete=false;
	return;
} 

PHP_METHOD(XairaServer,getXairaCorpora) { 
	int i;
	if (ZEND_NUM_ARGS() > 0) WRONG_PARAM_COUNT;
	array_init(return_value);
	for (i=0;i<gcc();i++) {
		char* key=(char*) gcn(i);
		char* path=(char*) gcp(i);
		add_assoc_string_ex(return_value,key,strlen(key)+1,path,1);
	}
	return;
} 

PHP_METHOD(XairaServer,getXairaServer) { 
	if (ZEND_NUM_ARGS() > 1) WRONG_PARAM_COUNT;
	int k; char* cn; int na;
	na=ZEND_NUM_ARGS();
	zend_parse_parameters(na TSRMLS_CC,"|s",&cn,&k);
	void* v=na?_getServer(cn):_getServer(NULL);
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairaServer);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
} 



PHP_METHOD(XairaServer,getCorpusName) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	RETURN_STRING((char*) _getCorpusName(v),1);
}

PHP_METHOD(XairaServer,getCorpusPath) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	RETURN_STRING((char*) _getCorpusPath(v),1);
}


PHP_METHOD(XairoSolution,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Solution_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoWordList,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=WordList_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoWordList,getWord) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* id=getThis();
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* w=WordList_getWord(xo->ptr,k);
	if (w==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoWord);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=w;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoAddkeyValueList,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=AddkeyValueList_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoAddkeyValueList,getAddkeyValue) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* id=getThis();
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* w=AddkeyValueList_getAddkeyValue(xo->ptr,k);
	if (w==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoAddkeyValue);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=w;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoAttributeValueList,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=AttributeValueList_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoAttributeValueList,getAttributeValue) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* id=getThis();
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* w=AttributeValueList_getAttributeValue(xo->ptr,k);
	if (w==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoAttributeValue);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=w;
	x->bInit=true;
	return;
}



PHP_METHOD(XairaServer,getWordList) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() == 0 || ZEND_NUM_ARGS() > 2) WRONG_PARAM_COUNT;
	char* s; int ls; char* l=""; int ll;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"s|s",&s,&ls,&l,&ll);
	void* vv;
	try {
		vv=_getWordList(v,s,l);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();
	}
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoWordList);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->dt=2;
	x->bInit=true;
	return;
}

PHP_METHOD(XairaServer,getAddkeyValueList) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoGrammarAddkey);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	void* vf=xof->ptr;
	void* vv;
	try {
		vv=_getAddkeyValueList(v,vf);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoAddkeyValueList);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}

PHP_METHOD(XairaServer,getAttributeValueList) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoGrammarAttribute);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	void* vf=xof->ptr;
	void* vv;
	try {
		vv=_getAttributeValueList(v,vf);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoAttributeValueList);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}


PHP_METHOD(XairaServer,getFrequencyList) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() == 0 || ZEND_NUM_ARGS() > 5) WRONG_PARAM_COUNT;
	char* s; int ls; char* l=""; int ll; long maxn, maxf, minf;
	maxn=0; minf=0; maxf=-1;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"s|llls",&s,&ls,&maxn,&minf,&maxf,&l,&ll);
	void* vv;
	try {
		vv=_getFrequencyList(v,s,maxn,minf,maxf,l);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoWordList);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	x->dt=2;
	return;
}

PHP_METHOD(XairaServer,getFilteredFrequencyList) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	zval* idf;
	if (ZEND_NUM_ARGS() != 6) WRONG_PARAM_COUNT;
	char* s; int ls; char* l=""; int ll; long maxn, maxf, minf;
	maxn=0; minf=0; maxf=-1;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"slllsO",&s,&ls,&maxn,&minf,&maxf,&l,&ll,&idf);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	void* vv;
	try {
		vv=_getFilteredFrequencyList(v,s,maxn,minf,maxf,l,xof->ptr);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoWordList);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->dt=2;
	x->bInit=true;
	return;
}



PHP_METHOD(XairaServer,getUsage) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	long i;
	zend_parse_parameters(1 TSRMLS_CC,"l",&i);
	void* vv;
	vv=_getUsage(v,(int) i);
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoExtendedForm);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	x->dt=4;
	return;
}

PHP_METHOD(XairaServer,solve) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	void* vv=NULL;
	try {
		vv=_solve(v,s);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();
	}
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	x->dt=3;
	return;
}

PHP_METHOD(XairaServer,deserialize) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	void* vv;
	vv=_deserialize(v,s);
	if (strncmp(s,"sol",3)==0)
		object_init_ex(return_value,ce_XairoSolution);
	else if (strncmp(s,"ctf",3)==0)
		object_init_ex(return_value,ce_XairoCorpusTextFilter);
	else except("Cannot deserialize Xairo object" TSRMLS_CC);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}

PHP_METHOD(XairaServer,getGrammar) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	void* vv;
	vv=_getGrammar(v);
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoGrammar);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	x->bDelete=false;
	return;
}

PHP_METHOD(XairaServer,getCorpusTextList) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=xo->ptr;
	void* vv;
	vv=_getCorpusTextList(v);
	if (vv==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoCorpusTextList);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=vv;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoSolution,getHit) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	long k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	try {
		v=Solution_getHit(xo->ptr,(int) k);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoHit);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoSolution,thinCorpusTextFilter) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoCorpusTextFilter);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	void* v;
	try {
		v=Solution_thinCorpusTextFilter(xo->ptr,xof->ptr);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();
	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->dt=3;
	return;
}

PHP_METHOD(XairoSolution,thinRand) { 
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	long n; long s;
	zend_parse_parameters(2 TSRMLS_CC,"ll",&n,&s);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	try {
		v=Solution_thinRand(xo->ptr,n,s);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->dt=3;
	return;
}

PHP_METHOD(XairoSolution,thinInit) {
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	long n; 
	zend_parse_parameters(1 TSRMLS_CC,"l",&n);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	try {
		v=Solution_thinInit(xo->ptr,n);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->dt=3;
	return;
}
PHP_METHOD(XairoSolution,thinOnePerText) { 
	if (ZEND_NUM_ARGS() != 0) WRONG_PARAM_COUNT;
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	try {
		v=Solution_thinOpt(xo->ptr);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->dt=3;
	return;
}

PHP_METHOD(XairoSolution,thinSelection) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* sel; zval** data; int acount; int* p;
	zend_parse_parameters(1 TSRMLS_CC,"a",&sel);
	HashTable* arr_hash; HashPosition pointer;
	arr_hash=Z_ARRVAL_P(sel);
	acount=zend_hash_num_elements(arr_hash);
	p=new int[acount];
	int ip=0;
	for (zend_hash_internal_pointer_reset_ex(arr_hash, &pointer); 
		zend_hash_get_current_data_ex(arr_hash, (void**) &data, &pointer) == SUCCESS;
		zend_hash_move_forward_ex(arr_hash, &pointer)) {
			long x=Z_LVAL_PP(data);
			p[ip++]=(int) x;        
	}
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	try {
		v=Solution_thinSelection(xo->ptr,acount,p);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->dt=3;
	return;
}


PHP_METHOD(XairoSolution,thinCollocation) { 
	if (ZEND_NUM_ARGS() != 3) WRONG_PARAM_COUNT;
	zval* sel; zval** data; zval* window; int acount; const char** p;
	char* ls; int lls;
	zend_parse_parameters(3 TSRMLS_CC,"saa",&ls,&lls,&window,&sel);
	HashTable* arr_hash; HashPosition pointer;
	arr_hash=Z_ARRVAL_P(sel);
	acount=zend_hash_num_elements(arr_hash);
	p=new const char*[acount];
	int ip=0;
	for (zend_hash_internal_pointer_reset_ex(arr_hash, &pointer); 
		zend_hash_get_current_data_ex(arr_hash, (void**) &data, &pointer) == SUCCESS;
		zend_hash_move_forward_ex(arr_hash, &pointer)) {
			const char* x=Z_STRVAL_PP(data);
			p[ip++]=x;        
	}
	HashTable* win_hash=Z_ARRVAL_P(window);
	int bX=0; int wl=3; int wr=3;  zval** kv;	
	zval* id=getThis(); const char* el; const char* ns;
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	if (win_hash && zend_hash_find(win_hash,"bX",sizeof("bX"),(void**) &kv)==SUCCESS)
		bX=Z_LVAL_PP(kv) != 0;

	if (!bX) {
		if (zend_hash_find(win_hash,"wl",sizeof("wl"),(void**) &kv)==SUCCESS)
			wl=Z_LVAL_PP(kv);
		if (zend_hash_find(win_hash,"wr",sizeof("wr"),(void**) &kv)==SUCCESS)
			wr=Z_LVAL_PP(kv);		
		v=Solution_thinCollocation(xo->ptr,ls,wl,wr,ip,p);

	} else {
		if (zend_hash_find(win_hash,"s",sizeof("s"),(void**) &kv)==SUCCESS)
			el=Z_STRVAL_PP(kv);
		if (zend_hash_find(win_hash,"ns",sizeof("ns"),(void**) &kv)==SUCCESS)
			ns=Z_STRVAL_PP(kv);
		v=Solution_thinCollocationX(xo->ptr,ls,el,ns,ip,p);

	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoSolution);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->dt=3;
	return;
}


PHP_METHOD(XairoSolution,analysis)
{
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* part; zval** data; int acount; int* p;
	HashTable* arr_hash; HashPosition pointer;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"a",&part);
	arr_hash=Z_ARRVAL_P(part);
	acount=zend_hash_num_elements(arr_hash);
	p=new int[acount];
	int ip=0; int km=0;
	for (zend_hash_internal_pointer_reset_ex(arr_hash, &pointer); 
		zend_hash_get_current_data_ex(arr_hash, (void**) &data, &pointer) == SUCCESS;
		zend_hash_move_forward_ex(arr_hash, &pointer)) {
			long x=Z_LVAL_PP(data);
			if (x > km) km=x;
			p[ip++]=(int) x;
        
	}
	int nb=km+1;
	int* a=new int[nb];
	int* at=new int[nb];
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	Solution_analysis(xo->ptr,acount,p,nb,a,at);
	array_init(return_value);
	for (int i=0;i<nb;i++) 
		add_next_index_long(return_value,a[i]);
	return;	
}

PHP_METHOD(XairoSolution,serialize) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Solution_serialize(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoSolution,makeCollocationTable) { 
	if (ZEND_NUM_ARGS() > 8) WRONG_PARAM_COUNT;// make some optional
	char* pattern=".*"; char* key=""; int lp, lk;
	long method=0; zval* window=NULL;
	long maxn=20, lowf=0;
	double mins=-1E50, maxs=1E50;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,"|sslalddl",&pattern,&lp,
		&key,&lk,&method,&window,
		&maxn,&mins,&maxs,&lowf);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	HashTable* htab=NULL;
	if (window) htab=Z_ARRVAL_P(window);
	bool bX=false;
	int winl=3, winr=3; char* el, *ns;
	zval** kv;
	if (htab && zend_hash_find(htab,"bX",sizeof("bX"),(void**) &kv)==SUCCESS)
		bX=Z_LVAL_PP(kv) != 0;
	void* v;
	if (!bX) {
		if (htab && zend_hash_find(htab,"wl",sizeof("wl"),(void**) &kv)==SUCCESS)
			winl=Z_LVAL_PP(kv);
		if (htab && zend_hash_find(htab,"wr",sizeof("wr"),(void**) &kv)==SUCCESS)
			winr=Z_LVAL_PP(kv);
		v=Solution_makeCollocationTable(xo->ptr,pattern,key,method,winl,winr,
			maxn,mins,maxs,lowf);
	}
	else { 
		if (htab && zend_hash_find(htab,"s",sizeof("s"),(void**) &kv)==SUCCESS)
			el=Z_STRVAL_PP(kv);
		if (htab && zend_hash_find(htab,"ns",sizeof("ns"),(void**) &kv)==SUCCESS)
			ns=Z_STRVAL_PP(kv);
		v=Solution_makeCollocationTableX(xo->ptr,pattern,key,method,el,ns,
			maxn,mins,maxs,lowf);
	}

	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoCollocationTable);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoCollocationTable,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=CollocationTable_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoCollocationTable,getCollocate) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=CollocationTable_getCollocate(xo->ptr,k);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoCollocate);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoWord,getFrequency) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Word_getFrequency(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoWord,getFilteredFrequency) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoCorpusTextFilter);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Word_getFilteredFrequency(xo->ptr,xof->ptr);
	RETURN_LONG(n);
}


PHP_METHOD(XairoWord,getFormCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Word_getFormCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoWord,getNorm) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	long k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Word_getNorm(xo->ptr,k);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoWord,getForm) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Word_getForm(xo->ptr,k);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoForm);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoAddkeyValue,getValue) { 
	if (ZEND_NUM_ARGS() != 0) WRONG_PARAM_COUNT;
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=AddkeyValue_getValue(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoAddkeyValue,getFrequency) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=AddkeyValue_getFrequency(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoAttributeValue,getValue) { 
	if (ZEND_NUM_ARGS() != 0) WRONG_PARAM_COUNT;
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=AttributeValue_getValue(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoAttributeValue,getFrequency) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=AttributeValue_getFrequency(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoAttributeValue,getFilteredFrequency) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoCorpusTextFilter);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=AttributeValue_getFilteredFrequency(xo->ptr,xof->ptr);
	RETURN_LONG(n);
}



PHP_METHOD(XairoForm,getNorm) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Form_getNorm(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoForm,getText) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Form_getText(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoForm,getFrequency) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Form_getFrequency(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoForm,getFilteredFrequency) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoCorpusTextFilter);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Form_getFilteredFrequency(xo->ptr,xof->ptr);
	RETURN_LONG(n);
}




PHP_METHOD(XairoForm,getAdditionalKey) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* ss=Form_getAdditionalKey(xo->ptr,s);
	RETURN_STRING(ss,1);
}

void xplog(char* s)
{
	FILE* hf=fopen("/home/xaira/xplog.txt","a");
	fprintf(hf,s);
	fclose(hf);
}

PHP_METHOD(XairoHit,getText) { 
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	long n=0; long m=-1;
	zend_parse_parameters(2 TSRMLS_CC,"ll",&n,&m);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
//	xplog("About to get hit");
	char* c=Hit_getText(xo->ptr,(int) n,-1);
//	xplog("Got hit");
//	xplog(c);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoHit,getCorpusText) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Hit_getCorpusText(xo->ptr);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoCorpusText);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoHit,getUnit) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=Hit_getUnit(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoHit,getCursorStart) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int i=Hit_getCursorStart(xo->ptr);
	RETURN_LONG(i);
}

PHP_METHOD(XairoHit,getCursorEnd) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int i=Hit_getCursorEnd(xo->ptr);
	RETURN_LONG(i);
}

PHP_METHOD(XairoCorpusText,getTitle) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=CorpusText_getTitle(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoCorpusText,evalXpath) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v;
	try {
		v=CorpusText_evalXpath(xo->ptr,s);
	}
	catch (CXairoPHPError* e)
	{
		except(e->getMessage() TSRMLS_CC);
		RETURN_NULL();

	}
	if (v==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoXpathValue);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoCorpusText,isSelected) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoCorpusTextFilter);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	bool b=CorpusText_isSelected(xo->ptr,xof->ptr);
	RETURN_BOOL(b?1:0);
}

PHP_METHOD(XairoCorpusText,classify) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* idf;
	zend_parse_parameters(1 TSRMLS_CC,"O",&idf,ce_XairoGrammarPartition);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	xaira_object* xof=(xaira_object*) zend_object_store_get_object(idf TSRMLS_CC);
	int n=CorpusText_classify(xo->ptr,xof->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoCorpusText,getWordCount) { 
	if (ZEND_NUM_ARGS() != 0) WRONG_PARAM_COUNT;
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=CorpusText_getWordCount(xo->ptr);
	RETURN_LONG(n);
}


PHP_METHOD(XairoCorpusTextList,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=CorpusTextList_getCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoCorpusTextList,getCorpusText) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* id=getThis();
	long k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* t=CorpusTextList_getCorpusText(xo->ptr,(int) k);
	if (t==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoCorpusText);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=t;
	x->bInit=true;
	return;
}

PHP_METHOD(XairoCorpusTextFilter,serialize) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=CorpusTextFilter_serialize(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoCorpusTextList,getCorpusTextFilter) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	zval* id=getThis();
	zval* a;
	zend_parse_parameters(1 TSRMLS_CC,"a",&a);
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	HashTable* hta=a->value.ht;
	int nt=zend_hash_num_elements(hta);
	int* t=new int [nt];
	for (int i=0;i<nt;i++) {
		zval** x;
		zend_hash_index_find(hta,i,(void**) &x);
		t[i]=Z_LVAL_PP(x);
	}
	void* f=CorpusTextList_getCorpusTextFilter(xo->ptr,nt,t);
	if (f==NULL) {
		RETURN_NULL();
	}
	object_init_ex(return_value,ce_XairoCorpusTextFilter);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=f;
	x->bInit=true;
	x->dt=1;
	return;
}

PHP_METHOD(XairoGrammar,getAddkeyCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Grammar_getAddkeyCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoGrammar,getAddkey) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Grammar_getAddkey(xo->ptr,k);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoGrammarAddkey);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->bDelete=false;
	return;
}

PHP_METHOD(XairoGrammar,getLemmaSchemeCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Grammar_getLemmaSchemeCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoGrammar,getLemmaScheme) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Grammar_getLemmaScheme(xo->ptr,k);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoGrammarLemmaScheme);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->bDelete=false;
	return;
}

PHP_METHOD(XairoGrammar,getRootPartition) { 
	if (ZEND_NUM_ARGS() != 0) WRONG_PARAM_COUNT;
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Grammar_getRootPartition(xo->ptr);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoGrammarPartition);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->bDelete=false;
	return;
}

PHP_METHOD(XairoGrammar,getElementCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Grammar_getElementCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoGrammar,getElement) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Grammar_getElement(xo->ptr,k);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoGrammarElement);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->bDelete=false;
	return;
}

PHP_METHOD(XairoGrammarAddkey,getName) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarAddkey_getName(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarAddkey,isLemmaScheme) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	bool b=GrammarAddkey_isLemmaScheme(xo->ptr);
	RETURN_BOOL(b);
}

PHP_METHOD(XairoGrammarLemmaScheme,getName) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarLemmaScheme_getName(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarLemmaScheme,getGloss) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarLemmaScheme_getGloss(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarLemmaScheme,getFacetCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=GrammarLemmaScheme_getFacetCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoGrammarLemmaScheme,getFacet) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	long k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarLemmaScheme_getFacet(xo->ptr,k);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarPartition,getName) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarPartition_getName(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarPartition,getDescription) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarPartition_getDescription(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarPartition,getCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	long k=GrammarPartition_getCount(xo->ptr);
	RETURN_LONG(k);
}

PHP_METHOD(XairoGrammarPartition,getDivision) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	long k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=GrammarPartition_getDivision(xo->ptr,k);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoGrammarPartition);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->bDelete=false;
	return;
}

PHP_METHOD(XairoGrammarElement,getName) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarElement_getName(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarElement,getGloss) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarElement_getGloss(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarElement,getNamespace) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarElement_getNamespace(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarElement,getAttributeCount) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=GrammarElement_getAttributeCount(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoGrammarElement,getAttribute) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=GrammarElement_getAttribute(xo->ptr,k);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoGrammarAttribute);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	x->bDelete=false;
	return;
}

PHP_METHOD(XairoGrammarAttribute,getName) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarAttribute_getName(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarAttribute,getGloss) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarAttribute_getGloss(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairoGrammarAttribute,getNamespace) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=GrammarAttribute_getNamespace(xo->ptr);
	RETURN_STRING(s,1);
}



PHP_METHOD(XairoCollocate,getWord) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	void* v=Collocate_getWord(xo->ptr);
	if (v==NULL) RETURN_NULL();
	object_init_ex(return_value,ce_XairoWord);
	xaira_object* x=(xaira_object*) zend_objects_get_address(return_value TSRMLS_CC);
	x->ptr=v;
	x->bInit=true;
	return;
}


PHP_METHOD(XairoCollocate,getHits) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int n=Collocate_getHits(xo->ptr);
	RETURN_LONG(n);
}

PHP_METHOD(XairoCollocate,getScore) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	double d=Collocate_getScore(xo->ptr);
	RETURN_DOUBLE(d);
}

PHP_METHOD(XairoExtendedForm,getType) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	int d=ExtendedForm_getType(xo->ptr);
	RETURN_LONG(d);
}

PHP_METHOD(XairoExtendedForm,getNorm) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=ExtendedForm_getNorm(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoExtendedForm,getText) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=ExtendedForm_getText(xo->ptr);
	RETURN_STRING(c,1);
}

PHP_METHOD(XairoExtendedForm,getData) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	int k;
	zend_parse_parameters(1 TSRMLS_CC,"l",&k);
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* c=ExtendedForm_getData(xo->ptr,k);
	RETURN_STRING(c,1);
}


PHP_METHOD(XairoXpathValue,getText) { 
	zval* id=getThis();
	xaira_object* xo=(xaira_object*) zend_object_store_get_object(id TSRMLS_CC);
	char* s=XpathValue_getText(xo->ptr);
	RETURN_STRING(s,1);
}

PHP_METHOD(XairaServer,transcode) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	char* w=_transcode(s);
	RETURN_STRING(w,1);
}


PHP_METHOD(XairaServer,transcode2) { 
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	char* s; int ls;
	zend_parse_parameters(1 TSRMLS_CC,"s",&s,&ls);
	char* w=_transcode2(s);
	RETURN_STRING(w,1);
}



}

#ifdef _WIN32
//#include "windows.h"
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

#endif
